/*
 * generated by Xtext 2.18.0.M3
 */
package tdt4250.ra.ide.contentassist.antlr;

import com.google.common.collect.ImmutableMap;
import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.Map;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;
import tdt4250.ra.ide.contentassist.antlr.internal.InternalRax1Parser;
import tdt4250.ra.services.Rax1GrammarAccess;

public class Rax1Parser extends AbstractContentAssistParser {

	@Singleton
	public static final class NameMappings {
		
		private final Map<AbstractElement, String> mappings;
		
		@Inject
		public NameMappings(Rax1GrammarAccess grammarAccess) {
			ImmutableMap.Builder<AbstractElement, String> builder = ImmutableMap.builder();
			init(builder, grammarAccess);
			this.mappings = builder.build();
		}
		
		public String getRuleName(AbstractElement element) {
			return mappings.get(element);
		}
		
		private static void init(ImmutableMap.Builder<AbstractElement, String> builder, Rax1GrammarAccess grammarAccess) {
			builder.put(grammarAccess.getNameOrStringAccess().getAlternatives(), "rule__NameOrString__Alternatives");
			builder.put(grammarAccess.getDepartmentAccess().getGroup(), "rule__Department__Group__0");
			builder.put(grammarAccess.getCourseAccess().getGroup(), "rule__Course__Group__0");
			builder.put(grammarAccess.getCourseAccess().getGroup_4(), "rule__Course__Group_4__0");
			builder.put(grammarAccess.getCourseAccess().getGroup_4_1(), "rule__Course__Group_4_1__0");
			builder.put(grammarAccess.getResourceAllocationAccess().getGroup(), "rule__ResourceAllocation__Group__0");
			builder.put(grammarAccess.getDepartmentAccess().getShortNameAssignment_0(), "rule__Department__ShortNameAssignment_0");
			builder.put(grammarAccess.getDepartmentAccess().getNameAssignment_2(), "rule__Department__NameAssignment_2");
			builder.put(grammarAccess.getDepartmentAccess().getPersonsAssignment_4(), "rule__Department__PersonsAssignment_4");
			builder.put(grammarAccess.getDepartmentAccess().getCoursesAssignment_6(), "rule__Department__CoursesAssignment_6");
			builder.put(grammarAccess.getPersonAccess().getNameAssignment(), "rule__Person__NameAssignment");
			builder.put(grammarAccess.getCourseAccess().getCodeAssignment_0(), "rule__Course__CodeAssignment_0");
			builder.put(grammarAccess.getCourseAccess().getNameAssignment_2(), "rule__Course__NameAssignment_2");
			builder.put(grammarAccess.getCourseAccess().getAllocationsAssignment_4_0(), "rule__Course__AllocationsAssignment_4_0");
			builder.put(grammarAccess.getCourseAccess().getAllocationsAssignment_4_1_1(), "rule__Course__AllocationsAssignment_4_1_1");
			builder.put(grammarAccess.getResourceAllocationAccess().getPersonAssignment_0(), "rule__ResourceAllocation__PersonAssignment_0");
			builder.put(grammarAccess.getResourceAllocationAccess().getPercentageAssignment_1(), "rule__ResourceAllocation__PercentageAssignment_1");
		}
	}
	
	@Inject
	private NameMappings nameMappings;

	@Inject
	private Rax1GrammarAccess grammarAccess;

	@Override
	protected InternalRax1Parser createParser() {
		InternalRax1Parser result = new InternalRax1Parser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		return nameMappings.getRuleName(element);
	}

	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}

	public Rax1GrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(Rax1GrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
	
	public NameMappings getNameMappings() {
		return nameMappings;
	}
	
	public void setNameMappings(NameMappings nameMappings) {
		this.nameMappings = nameMappings;
	}
}
